! funcload.for -- Defines the two functions 'SRELoadFuncs' and 'SREDropFuncs',
!                 which load/drop all the functions defined in this DLL.

c$define INCL_REXXSAA
c$include rexxsaa.fap

! Declare our functions.  Make sure to export these in the .LNK file!

c$pragma aux (RexxFunctionHandler) SRELoadFuncs "SRELoadFuncs"
c$pragma aux (RexxFunctionHandler) SREDropFuncs "SREDropFuncs"

! Define the table that lists REXX function names and the corresponding
! DLL entry point.  You must change this table whenever you add/remove
! a function or entry point.

	blockdata
	include 'funcload.fi'
	data RxFncTable/
		! function	entry point
     &		'SRELoadFuncs'c,  'SRELoadFuncs'c,
     &		'SREDropFuncs'c,  'SREDropFuncs'c,
     &		'SRE_LOCALVARS'c,      'SRE_LOCALVARS'c,
     &		'SRE_SYSVARS'c,      'SRE_SYSVARS'c,
     &		'SRE_CACHE1'c,      'SRE_CACHE1'c,
     &		'SRE_CACHE_IPNAME'c,      'SRE_CACHE_IPNAME'c,
     &		'SRE_PAUSE'c,      'SRE_PAUSE'c,
     &		'SRE_REQ_CACHE'c,      'SRE_REQ_CACHE'c,
     &		'SRE_MD5S_CACHE'c,        'SRE_MD5S_CACHE'c,
     &		'SRE_SHUTDOWN'c,      'SRE_SHUTDOWN'c,
     &		'SRE_SAVEVALS'c,      'SRE_SAVEVALS'c,
     &		'SRE_COUNTVARS'c,      'SRE_COUNTVARS'c,
     &		'SRE_HOSTINFO'c,      'SRE_HOSTINFO'c/
	end

! SRELoadFuncs -- Register all the functions with REXX.

c$noreference
	integer function SRELoadFuncs( name, numargs, args,
     &				      queuename, retstr )
c$reference
	integer numargs, name, queuename
	record /RXSTRING/ args(numargs), retstr
	
	include 'rxsutils.fi'
	include 'funcload.fi'
	
    	integer j
	character*9 DLLNAME ! Change this if you're changing the DLL name...
	parameter (DLLNAME = 'SRE2000'c)
	
	retstr.strlength = 0

	if( numargs .gt. 0 )then
	    SRELoadFuncs = INVALID_ROUTINE
	    return
	endif

	do j = 1, ENTRIES
	    call RexxRegisterFunctionDll( RxFncTable(j).rxName, DLLNAME,
     &					  RxFncTable(j).cName )
	enddo

	SRELoadFuncs = VALID_ROUTINE

	end

* SREDropFuncs -- Deregister all the functions with REXX.

c$noreference
	integer function SREDropFuncs( name, numargs, args,
     &				      queuename, retstr )
c$reference
	integer numargs, name, queuename
	record /RXSTRING/ args(numargs), retstr
	
	include 'rxsutils.fi'
	include 'funcload.fi'
	
	integer j

	retstr.strlength = 0

	if( numargs .gt. 0 )then
	    SREDropFuncs = INVALID_ROUTINE
	    return
	endif

	do j = 1, ENTRIES
	    call RexxDeregisterFunction( RxFncTable(j).rxName )
	enddo

	SREDropFuncs = VALID_ROUTINE

	end
