c read/ save variables in LOCAL "REQUEST SPECIFIC" space                    

c$define INCL_REXXSAA
c$include rexxsaa.fap

! Declare our exported function.  Export it!

c$pragma aux (RexxFunctionHandler) SRE_LOCALVARS "SRE_LOCALVARS"

! SRE_LOCALVARS -- store variables 

c$noreference
	integer function SRE_LOCALVARS( name, numargs, args,
     &                            queuename, retstr )
c$reference

	character*(*) name, queuename
	integer numargs
	record /RXSTRING/ retstr, args(numargs)

        CHARACTER *2 CRLF        
	include 'rxsutils.fi'

	character*(*) tmp,arg1,arg2,arg3,arg4,ARG5,arg6,arg7,arg8,arg9
        integer maxthreads,MAXLOCALS,maxthreads3,SLOT  
        save maxthreads,MAXLOCALS,maxthreads3
        volatile maxthreads,MAXLOCALS,maxthreads3
                  
        integer ii,nactive,mm2
               
        integer usetid,threadid,setlength,jindx,iat,jmm3

        data maxthreads/50/

        character *80 storage(:,:),HNICK15
        character *25 storage_name(:,:)
        integer *2 istorage(:)
        LOGICAL QMATCH

        character *8 SOCKET(:),usesock
        integer *2 PARINDEX(:),NSLOTS
        logical completed(:)
        character *80 SEMQUEUE(:)
        character *80 sels(:),asel
        character *30 starttime(:)
        character *15 clientaddr(:)
        integer *2 kid_tids(:)
        

        character *15 host_nickname(:),aword
        character *162 aline

        save istorage,storage_name,storage    !for storing custom variables
        save semqueue,SOCKET,PARINDEX   !for storing special variables
        save NSLOTS,completed,host_nickname,sels,starttime,clientaddr

        volatile istorage,storage_name,storage    !for storing custom variables
        volatile semqueue,SOCKET,PARINDEX   !for storing special variables
        volatile NSLOTS,completed,host_nickname,sels,starttime,clientaddr
       
        integer mm,tmplen,ierr1,isum,imm,itmp

c gotta be a few arguments
	if( numargs .lt. 1.or.numargs.gt.10 )then
           SRE_LOCALVARS = 443
          return
	endif

c   arg1 = varname 
c   arg2 = value [if no value, then "lookup"]
c   arg3 = threadid [optional, program will determine if not specified]
C   ARG4 = "NO SUCH VAR" FLAG    (used if custom variable)
c
c special arg1 values: !STARTUP = initialize; 
c                            arg2=max # of threads (2x max # of simultaneous connections),
c                            arg3=# OF thread specific variables
c                      !CLEAR = clear this slot
c                      !INIT = initialize this slot
c                             arg2 = socket
c                             arg3 = threadids (of "child" and "parent" threads)
c                             arg4 = storage "slot" to use
c                             arg5 = semqueue
c                             arg6 = host_Nickname
c                             arg7 = selector
c                             arg8 = partid_transaction_starttime (1/100 seconds)
c                             arg9 = clientaddress
        
c get varname
        deallocate(arg1,stat=ierr1)
        allocate( arg1*args(1).strlength, location=args(1).strptr )
        call strip_arg(arg1)


c tmp is used as the response
c tmp is often a status code, with
c  1 = ok 
c  ERROR_xxx = an error
c if "get value", then tmp will be the value (or ' ', if no such varname, or if error)

       deallocate(tmp,stat=ierr1)
       allocate(tmp*80)        !1 char status response is the default
       tmplen=80

c STARTUP::: initialize?
        if (arg1.eq.'!STARTUP') then             !allocate STORAGE arrays 
           execute do_startup
           goto 2000
        endif

        tmp='ERROR_NOT_INIT'
        if (maxthreads.eq.0) goto 2000          !forgot to initialize

c probably will need arg2 
        setlength=0
        if (numargs.gt.1) then
          if (args(2).strlength.gt.0) then          !get the value 
              allocate( arg2*args(2).strlength, 
     1                  location=args(2).strptr )
              setlength=args(2).strlength
           else
               allocate(arg2*1)
               arg2=' '
           endif
        else
           allocate(arg2*1)
           arg2=' '
       endif

c arg3 had threadid. If not specified, look it up
        if (numargs.lt.3) then          ! no 3rd arg -- assume thread specific var
            usetid=threadid()           
        else
          if (args(3).strlength.eq.0) then      !empty 3rd arg-- assume thread specific var
             usetid=threadid()
          else
             allocate( arg3*args(3).strlength, location=args(3).strptr)
             tmp='ERROR_BAD_THREADID_'//arg3
             read(arg3,*,iostat=ierr1)usetid
             if (ierr1.ne.0) goto 2000          !some kind of error determining threadid
          endif
        endif

c        write(6,*)arg1,arg2,usetid

        if (usetid.lt.0.or.usetid.gt.maxthreads3) then
          tmp='ERROR_THREADID_OUT_OF_BOUNDS'
          goto 2000  !bad threadid
        endif


c !FREESLOT:: find a free "slot" for this "parent threads" storage (kid thread also
c              stores stuff in the parent's slot)
c note: this is ONLY called by sre2000.cmd -- which guarantees no thread clashing
        if (arg1.eq.'!FREESLOT') then
            tmp='0'                    !0 means "no slot is free"
            read(arg2,*,iostat=ierr1)mm2
            if (ierr1.ne.0) mm2=MAXTHREADS
            do mm=1,mm2
                if (socket(mm).eq.' ') then             ! this slot is free
                    write(aword,*)mm
                    tmp=aword
                    socket(mm)='0'              !0 is a placeholder
                    goto 2000
                endif
            enddo
            goto 2000           !if here, return '0'
        ENDIF

c !CLEAR :::  zap this "client id's" storage
        if (arg1.eq.'!CLEAR') then               !clear is issued by the parent
            read(arg2,*,iostat=ierr1)mm2
            if (ierr1.ne.0) then
               tmp='ERROR_NO_SLOT_TO_CLEAR'
               goto 2000
            endif
            if (mm2.le.0.or.mm2.gt.maxthreads) then
                   tmp='ERROR_SLOT_LE_0'
                   goto 2000
             endif

             tmp='1'
             completed(mm2)=.true.
             semqueue(mm2)=' '               
             host_nickname(mm2)=' '
             sels(mm2)=' '
             clientaddr(mm2)=' '
             starttime(mm2)=' '
             jmm3=kid_tids(mm2)
                parindex(jmm3)=0
             kid_tids(mm2)=0
             istorage(mm2)=0
             SOCKET(mm2)=' '                  !SIGNALS THAT THIS SLOT IS FREE
             goto 2000            
        endif                   ! clear

c might need this index (Kid thread -- to --> parent slot)
        jindx=PARINDEX(usetid)          !reference to "parent threads" storage

       if (arg1.eq.'!CLIENTS') then             !COUNT ACTIVE CLIENTS
           isum=0
           do mm=1,NSLOTS
             if (SOCKET(MM).ne.' ') isum=isum+1  !completed may still be active transactions (keep-alived)
           enddo
           write(aword,897)isum
 897       format(i10)
           tmp=aword
           goto 2000
        endif


       if (arg1.eq.'!CLIENTLIST'.or.arg1.eq.'CLIENT_LIST') then     !COUNT ACTIVE CLIENTS
           deallocate(tmp,stat=ierr1)
           tmplen=max(nslots*15,80)
           allocate(tmp*tmplen)        !1 char status response is the default
           tmp=' '
           mm2=0
           do mm=1,NSLOTS
             if (SOCKET(MM).ne.' ') then 
                mm2=mm2+1
                write(aword,1011)mm
 1011           format(i6)
                iat=1+((mm2-1)*8)
                tmp(iat:iat+7)=aword
             endif
           enddo
           goto 2000
        endif


c INIT:: initialize this thread 
C CALLED AS:
c     foo=sre_localvars('!INIT',SOCKET,mytid,slotnum,SEMQUEUE,host_nickname, ,
c                           sel,id_time_stamp,clientaddr)
c where id_time_stamp=parent_tid' 'transaction' 'date' 'time

        if (arg1.eq.'!INIT') then
           tmp='ERROR_INIT_VARS_UNSPECIFIED'
           if (numargs.lt.9) goto 2000

           allocate( arg4*args(4).strlength, location=args(4).strptr )
           tmp='ERROR_BAD_CLIENT_NUMBER'
           read(arg4,*,iostat=ierr1)SLOT
           if (ierr1.ne.0) goto 2000          !some kind of error determining slot number

           PARINDEX(usetid)=SLOT
           kid_tids(slot)=usetid
           completed(slot)=.false.              !it's Not completed 
           istorage(SLOT)=0

           if (SLOT.gt.NSLOTS)NSLOTS=SLOT     ! nslots is max slots used to date

           call strip_arg(arg2)
           SOCKET(SLOT)=arg2

           allocate( arg5*args(5).strlength, location=args(5).strptr )
           call strip_arg(arg5)
           semqueue(SLOT)=arg5

           allocate( arg6*args(6).strlength,location=args(6).strptr)
           HNICK15=ARG6
           host_nickname(slot)=hnick15

           allocate( arg7*args(7).strlength,location=args(7).strptr)
           asel=ARG7
           sels(slot)=asel

           allocate( arg8*args(8).strlength,location=args(8).strptr)
           starttime(slot)=arg8

           allocate( arg9*args(9).strlength,location=args(9).strptr)
           clientaddr(slot)=arg9

           tmp='1'
           goto 2000            

        endif

c !INFO :: general info on what's stored
        if (arg1.eq.'!INFO'.and.setlength.eq.0) then 
           execute do_info
           goto 2000
        endif


c I!NFO :: general info on a particular client 
        if (arg1.eq.'!INFO'.and.setlength.gt.0) then 
           execute do_info_client
           goto 2000
        endif


C VARIABLE LOOKUP:: Global, thread-specific, custom-thread-specific

c Special value: is this request-thread still active?
        if (arg1.eq.'COMPLETED'.or.arg1.eq.'!COMPLETED') then 
           tmp='0'                        
           if (numargs.lt.2) then       ! lookup (for parent of the kid thread that asked
              if (jindx.eq.0) then   ! no such client id 
                 tmp='1'
              else
                 if (completed(jindx).or.socket(jindx).eq.' ') tmp='1'  
              endif
           else                               ! assign value TO A SLOT
              call strip_arg(arg2)
              mm2=usetid          !CAREFUL -- be sure arg3 is the "slot" (not the kid threadid)
              if (mm2.gt.0.and.mm2.le.maxthreads) then
                 if (arg2(1:1).eq.'Y'.or.arg2(1:1).eq.'1') then
                    completed(mm2)=.true.
                else
                    completed(mm2)=.false.
                endif
              endif
           endif
           goto 2000
           
        ENDIF

c now return a specific variable

c note: if slots=0, then this thread's info is not active --- but it still may have 
c values that other threads may want to read
           
      if (arg1.eq.'SEMQUEUE') then   ! 4 items in semqueue
                                     ! parsem' 'parqueue' 'mysem' 'myqueue 
            tmp='ERROR_CAN_NOT_MODIFY_SEMQUEUE'
            if (setlength.eq.0) then
               tmp=' '
               if (jindx.ne.0) tmp=semqueue(jindx)
            endif
           
        elseif (arg1(1:3).eq.'SEL') then
            tmp='ERROR_CAN_NOT_MODIFY_SELECTOR'
            if (setlength.eq.0) then
               tmp=' '
               if (jindx.ne.0) tmp=sels(jindx)
             endif

        elseif (arg1.eq.'CLIENTADDR') then
            tmp='ERROR_CAN_NOT_MODIFY_CLIENTADDR'
            if (setlength.eq.0) then
               tmp=' '
               if (jindx.ne.0) tmp=clientaddr(jindx)
             endif


        elseif (arg1.eq.'STARTTIME') then
            tmp='ERROR_CAN_NOT_MODIFY_STARTTIME'
            if (setlength.eq.0) then
               tmp=' '
               if (jindx.ne.0) tmp=starttime(jindx)
             endif

        elseif (arg1.eq.'CLIENT') then
            tmp='ERROR_READING_CLIENT_ID'
            if (setlength.ne.0) then
              read(arg2,*,iostat=ierr1)imm
              if (imm.gt.0.and.ierr1.ne.0.and.imm.le.maxthreads3)
     1                           write(aword,933)parindex(imm)
              tmp=aword
            else
                write(aword,933)jindx
                tmp=aword
            endif
 933        format(I6)
 9331       format(a)

        elseif (arg1.eq.'TID') then
            tmp='ERROR_READING_TID'
            imm=jindx
            ierr1=0
            if (setlength.ne.0) read(arg2,*,iostat=ierr1)imm
            if (ierr1.ne.1.and.imm.gt.0.and.imm.lt.maxthreads) 
     1                  write(aword,933) kid_tids(imm)
                        tmp=aword

        elseif (arg1.eq.'VARLIST') then
            if (jindx.le.0.or.jindx.gt.maxthreads) then
              tmp='ERROR_BAD_JINDX'
              goto 2000
            endif

            tmp=' '    
            if (istorage(jindx).eq.0) goto 2000

            deallocate(tmp,stat=ierr1)
            tmplen=max(80,istorage(jindx)*29)
            allocate( tmp*tmplen)        !1 char status response is the default
            tmp=' '    

            do mm2=1,istorage(jindx)
               iat=((mm2-1)*26)+1
               tmp(iat:iat+24)=storage_name(jindx,mm2)
            enddo
            goto 2000
           
        elseif (arg1.eq.'SOCKET') then
            tmp='ERROR_CAN_NOT_MODIFY_SOCKET'
            if (setlength.eq.0) then
               tmp=' '
               if (jindx.ne.0) tmp=SOCKET(jindx)
             endif
            
        elseif (arg1.eq.'HOST_NICKNAME') then
            tmp='ERROR_CAN_NOT_MODIFY_HOSTNICKNAME'
            if (setlength.eq.0) then
               tmp=' '
               if (jindx.ne.0) tmp=host_nickname(jindx)
             endif
            
        else                             ! custom varname 
            execute do_CUSTOM
        endif
           


c jump here to return status code stored in tmp
 2000    continue
        tmplen=max(1,lentrim(tmp))
       call CopyResult( tmp,tmplen, retstr )
c        write(6,*)tmp(1:max(1,tmplen))

       deallocate( tmp,stat=ierr1 )
       deallocate(arg1,stat=ierr1)
       deallocate(arg2,stat=ierr1)
       if (numargs.gt.2) deallocate(arg3,stat=ierr1)
       if (numargs.gt.3) deallocate(arg4,stat=ierr1)
       if (numargs.gt.4) deallocate(arg5,stat=ierr1)
       if (numargs.gt.5) deallocate(arg6,stat=ierr1)
       if (numargs.gt.6) deallocate(arg7,stat=ierr1)
       if (numargs.gt.7) deallocate(arg8,stat=ierr1)
       if (numargs.gt.8) deallocate(arg9,stat=ierr1)

       SRE_LOCALVARS = VALID_ROUTINE
       return


c======================= Blocks Section ===========================

c ---------------- STARTUP BLOCK  -----------
        Remote Block Do_startup

c read maxthreads and MAXLOCALS

        if (numargs.lt.3) then
           tmp='ERROR_NO_STARTUP_VALUES'
           exit
        endif
        allocate( arg2*args(2).strlength, location=args(2).strptr )
        allocate( arg3*args(3).strlength, location=args(3).strptr )

        NSLOTS=0
        read(arg2,*,iostat=ierr1)maxthreads
        tmp='ERROR_BAD_MAXTHREADS'
        if (ierr1.ne.0) exit        

        if (args(3).strlength.gt.0) then
            read(arg3,*,iostat=ierr1)MAXLOCALS
            if (ierr1.ne.0) then
              tmp='ERROR_BAD_MAXLOCALS'
              exit
           endif
        else
           tmp='ERROR_NO_MAXLOCALS'
           exit
        endif
        MAXLOCALS=min(MAXLOCALS,250)   !maximum 250 of custom storage per thread
        MAXLOCALS=max(MAXLOCALS,5)     ! miniumum of 5

c allocate storage space for custom variables

        deallocate(storage,stat=ierr1)
        allocate (storage(maxthreads,MAXLOCALS),stat=ierr1)
        if (ierr1.ne.0) then
                tmp='ERROR_ALLOCATE_STORAGE'
                exit
         endif
        deallocate(istorage,stat=ierr1)
        allocate (istorage(maxthreads),stat=ierr1)
        if (ierr1.ne.0) then
                tmp='ERROR_ALLOCATE_ISTORAGE'
                exit
         endif
        deallocate(storage_name,stat=ierr1)
        allocate (storage_name(maxthreads,MAXLOCALS),stat=ierr1)
        if (ierr1.ne.0) then
             tmp='ERROR_ALLOCATE_STORAGE_NAME'
             exit
         endif

        tmp='ERROR_ALLOCATING'
        deallocate(semqueue,stat=ierr1)
            allocate(semqueue(maxthreads),stat=ierr1)
            if (ierr1.ne.0) exit   !error in one of the allocates

        deallocate(sels,stat=ierr1)
            allocate(sels(maxthreads),stat=ierr1)
            if (ierr1.ne.0) exit   !error in one of the allocates

        deallocate(clientaddr,stat=ierr1)
            allocate(clientaddr(maxthreads),stat=ierr1)
            if (ierr1.ne.0) exit   !error in one of the allocates

        deallocate(starttime,stat=ierr1)
            allocate(starttime(maxthreads),stat=ierr1)
            if (ierr1.ne.0) exit   !error in one of the allocates

        deallocate(kid_tids,stat=ierr1)
            allocate(kid_tids(maxthreads),stat=ierr1)
            if (ierr1.ne.0) exit   !error in one of the allocates

        deallocate(host_nickname,stat=ierr1)
            allocate(host_nickname(maxthreads),stat=ierr1)
            if (ierr1.ne.0) exit   !error in one of the allocates

        deallocate(SOCKET,stat=ierr1)
            allocate (SOCKET(maxthreads),stat=ierr1)
            if (ierr1.ne.0) exit   !error in one of the allocates


        deallocate(COMPLETED,stat=ierr1)
            allocate (COMPLETED(maxthreads),stat=ierr1)
            if (ierr1.ne.0) exit   !error in one of the allocates


        maxthreads3=3*maxthreads     !allocate a lot of space for this int *2 index
        deallocate(PARINDEX,stat=ierr1)
            allocate (PARINDEX(maxthreads3),stat=ierr1)
            if (ierr1.ne.0) exit   !error in one of the allocates

c initialize to ' '
         do mm=1,maxthreads          !initialize SEMQUEUE and SOCKET
               SOCKET(mm)=' '
               semqueue(mm)=' '
               host_nickname(mm)=' '
               Istorage(mm)=0      !and storage space
               completed(mm)=.true.
         enddo
         do mm=1,maxthreads3
            parindex(mm)=0       !0 means "not active "
         enddo

         tmp='1'
         exit

        End Block


c ------------ Custom var block -----------

        Remote Block Do_CUSTOM
       tmp=' '
       QMATCH=.FALSE.
       if (jindx.eq.0) exit                     

       do mm=1,istorage(jindx)
          if (storage_name(jindx,mm)(1:3).ne.arg1(1:3)) cycle  ! preliminary check
          if (storage_name(jindx,mm).ne.arg1) cycle              !full check
          QMATCH=.TRUE.
          if (setlength.eq.0) then           !return value
                tmp=storage(jindx,mm)
                exit
           else                       !replace value
               tmp='1'
               storage_name(jindx,mm)=arg1
               storage(jindx,mm)=arg2
               exit
           endif
       enddo
       if (QMATCH.or.setlength.eq.0) exit  !found a match, or no match/no set

c local not found
       if (istorage(jindx).ge.maxlocals) then
             tmp='ERROR_TOO_MANY_LOCALS'
             exit
       endif
       tmp='1'
       mm=istorage(jindx)+1
       storage_name(jindx,mm)=arg1
       storage(jindx,mm)=arg2
       istorage(jindx)=mm

       exit
       end block


c------------- Info  ----
       remote block do_info  

        deallocate(tmp,stat=ierr1)

c 80 : # of values, # of columns
c 20+ncols*30: column names
c 20+ncols*10: number of values

        crlf(1:1)=char(13)
        crlf(2:2)=char(10)
        nactive=0 
        usesock=' '
        do mm=1,NSLOTS
            if (SOCKET(mm).ne.' ')  nactive=nactive+1
        enddo

        ii=122*max(nactive,1)
        ii=ii+170
        deallocate(tmp,stat=ierr1)
        allocate(tmp*ii,stat=ierr1)

        if (ierr1.ne.0) then 
           deallocate(tmp,stat=ierr1)
           allocate(tmp*80)
           tmp='error_can_not_allocate_enough_space'
           exit            !fatal error?
        endif

        tmp=' '

        write(aline,991,iostat=ierr1)maxthreads,maxlocals,
     1                  crlf,nactive,crlf
        tmp=aline
 991    format('Maximum number of clients= ',i5,
     1      ', w/',i5,' local variables.',a,
     1      '# of active clients=',i5,a)
        if (ierr1.ne.0) then
           tmp='error_writing_status_info'
           exit
        endif

c        do mm=1,nslots
c         if (socket(mm).eq.' ') cycle
c
c         atid=kid_tids(mm)
c         if (atid.eq.usetid) then    
c            write(aline,9921)mm,socket(mm),sels(mm),crlf
c9921        format(' ** ',i5,1x,a,' : ',a,a)
c          else
c            write(aline,9922)mm,socket(mm),sels(mm),crlf
c9922        format('    ',i5,1x,a,' : ',a,a)
c          endif
c          call add_string(tmp,aline)
c                    
c           do mm2=1,istorage(mm)
c               write(aline,*)' ',storage_name(mm,mm2)
c               call add_string(tmp,aline)
c           enddoc
c           call add_string(tmp,crlf)
c
c       enddo

        exit
        end block


c------------- Info on a client  ----
       remote block do_info_client  

        deallocate(tmp,stat=ierr1)

c return, in crlf delimited list
c client id (5 chars
c socket number (8 chars
c completed (1
c client numeric ip address (15
c start time (5 + 1 + 11 = 17 -- day hh:mm:ss.uu 
c host_nickname (15 
c selector (80

       deallocate(tmp,stat=ierr1)
       allocate( tmp*190)
       tmplen=190

        imm=jindx
        if (setlength.gt.0) then
             read(arg2,*,iostat=ierr1)imm
             if (ierr1.gt.0) then
                 tmp='error_bad_client_id'
                 exit
             endif
         endif

        if (imm.le.0.or.imm.gt.maxthreads) then
           tmp='ERROR_BAD_JINDX'
           exit
        endif

        crlf(1:1)=char(13)
        crlf(2:2)=char(10)
        tmp='wow'
         itmp=0
         if (completed(imm)) itmp=1
         write(aline,875)imm,crlf,socket(imm),crlf,itmp,crlf,
     1         clientaddr(imm),crlf,
     1         starttime(imm),crlf,host_nickname(imm),crlf,sels(imm)  
        tmp=aline 
         
  875    format(i5,a2,a8,a2,i1,a2,
     1         a15,a2,
     1         a26,a2,a15,a2,a80)



        exit


        end block

        END


c--------------
c add substring to end of string
        subroutine add_string(big1,add1)
        character *(*)big1,add1
        integer ibig1,ibig2,ichar,ia,mm
        ibig2=len(big1)
        ibig1=ibig2+1
        do mm=ibig2,1,-1
          ia=ichar(big1(mm:mm))
          if (ia.eq.10 .or. ia.eq.13.or.ia.eq.9.or.ia.gt.32) exit   !exit on first non-"space"
          ibig1=mm
        enddo
        if (ibig1.gt.ibig2) return              !no room in string
        big1(ibig1:ibig2)=add1
        return
        end

