c read/ save variables in static space -- "SYSTEM" variables

c$define INCL_REXXSAA
c$include rexxsaa.fap

! Declare our exported function.  Export it!

c$pragma aux (RexxFunctionHandler) SRE_HOSTINFO "SRE_HOSTINFO"

! SRE_HOSTINFO -- store variables 

c$noreference
	integer function SRE_HOSTINFO( name, numargs, args,
     &                            queuename, retstr )
c$reference

	character*(*) name, queuename
	integer numargs
	record /RXSTRING/ retstr, args(numargs)
        
	include 'rxsutils.fi'

	character*(*) tmp,arg2,arg3,arg1

        character *80 host_ip(:)
        character *80 host_dir(:)
        character *16 host_nick(:)
        integer nhosts,maxhosts
        save host_ip,host_dir,host_nick,nhosts,maxhosts
        volatile host_ip,host_dir,host_nick,nhosts,maxhosts

        data maxhosts/-1/
        data nhosts/0/

        character *2 crlf

        integer setlength,mm,tmplen,ierr1,jat,iat

        tmplen=80
        deallocate(tmp,stat=ierr1)

        allocate(tmp*tmplen)

c gotta be a few arguments
	if(numargs.gt.3 )then
           SRE_HOSTINFO = 443
           return
	endif

        if (numargs.gt.0) then
            allocate( arg1*args(1).strlength, location=args(1).strptr )
            call strip_arg(arg1)
        else
            allocate( arg1*10)
            arg1='!LIST'
        endif

        setlength=0
        if (numargs.gt.1) then
         if (args(2).strlength.gt.0) then          !get the value 
            allocate( arg2*args(2).strlength, location=args(2).strptr )
            setlength=args(2).strlength
         else
            allocate(arg2*1)
            arg2=' '
         endif
       endif

        if (arg1.eq.'!STARTUP') then
           nhosts=0
           TMP='ok '
           if (setlength.gt.0) then 
               read(arg2,*,iostat=ierr1)maxhosts
               if (ierr1.ne.0) then
                  tmp='error_bad_maxhosts'   !error in maxhosts read
                  goto 2000
               endif
           endif
           deallocate(host_ip,stat=ierr1)
            allocate (host_ip(maxhosts),stat=ierr1)
            if (ierr1.ne.0) tmp='error_allocating_hostip'   !error in one of the allocates

           deallocate(host_nick,stat=ierr1)
            allocate (host_nick(maxhosts),stat=ierr1)
            if (ierr1.ne.0) tmp='error_allocating_hostnick'   !error in one of the allocates

           deallocate(host_dir,stat=ierr1)
            allocate (host_dir(maxhosts),stat=ierr1)
            if (ierr1.ne.0) tmp='error_allocating_hostdir'   !error in one of the allocates
           goto 2000
        endif

        if (maxhosts.lt.0) then
          tmp='error_hostinfo_not_initialized'
          goto 2000
        endif

        if (arg1.eq.'!CLEAR') then
           nhosts=0
           TMP='ok'
           goto 2000
        endif

           
c IF here, read or write hostinfo

       crlf(1:1)=char(13)
       crlf(2:2)=char(10)

       tmp=' '

c Return list of currently defined hosts?
        if (arg1.eq.'!LIST'.or.arg1.eq.'!INFO') then          ! return status info
           if (nhosts.eq.0) goto 2000        !no hosts defined
           deallocate(tmp)              !else, create list of hosts
           jat=max(80,180*nhosts)
           if (arg1.eq.'!INFO')jat=jat+200
           allocate(tmp*jat)
           tmplen=1
           if (arg1.eq.'!INFO') then   ! write some descriptive info first 
               write(tmp,793)crlf,nhosts,maxhosts
 793           format('HostInfo status: ',a' Using ',i5,' of ',
     1                i5,' possible entries.' ) 
               tmplen=lentrim(tmp)+1
           endif      
           do iat=1,nhosts
              if (host_ip(iat).eq.' ') cycle
              if (tmplen.eq.1) then
                 tmp=host_ip(iat)(1:lentrim(host_ip(iat)))//','//
     1               host_nick(iat)(1:lentrim(host_nick(iat)))//','//
     1               host_dir(iat)(1:lentrim(host_dir(iat)))
              else
                 tmp=tmp(1:tmplen)//crlf//
     1               host_ip(iat)(1:lentrim(host_ip(iat)))//','//
     1               host_nick(iat)(1:lentrim(host_nick(iat)))//','//
     1               host_dir(iat)(1:lentrim(host_dir(iat)))//crlf
              endif
              tmplen=lentrim(tmp)+2
           enddo
           tmplen=lentrim(tmp)
           goto 2000
        endif

c lookup or set a particular host entry
        if (numargs.gt.1) then        
              allocate( arg2*args(2).strlength,location=args(2).strptr)  !the  nickname
              allocate( arg3*args(3).strlength,location=args(3).strptr)  !the datadir
              call strip_arg(arg2)
              call strip_arg(arg3)
         endif
         iat=0

         do mm=1,nhosts
             if (arg1(1:3).ne.host_ip(mm)(1:3)) cycle
             if (arg1.ne.host_ip(mm)) cycle
             iat=mm
             exit
         enddo

c found a match?
         if (iat.eq.0) then             ! No match found
              if (numargs.lt.2) goto 2000 !lookup, and not found
              if (nhosts.ge.maxhosts) then 
                   tmp='error_too_many_hosts'
                   goto 2000
               endif
               nhosts=nhosts+1
               iat=nhosts
         endif

c modify (or add) a value?
         if (numargs.gt.2) then               !change value
              if (arg2.eq.' ') then                !' ' nickname means "remove entry
                  host_ip(iat)=' '
                  host_dir(iat)=' '
                  host_nick(iat)=' '
                  tmp='ok'
                 goto 2000
              endif
              host_ip(iat)=arg1                !modify 
              host_nick(iat)=arg2
              host_dir(iat)=arg3
         endif
c        write(6,*)iat
c        write(6,*)' ip=',host_ip(iat)
c        write(6,*)'nick=',host_nick(iat)
c        write(6,*)'dir= ',host_dir(iat)

         deallocate(tmp,stat=ierr1)           !return info
         allocate(tmp*180,stat=ierr1)
         tmp=host_ip(iat)(1:lentrim(host_ip(iat)))//','//
     1         host_nick(iat)(1:lentrim(host_nick(iat)))//','//
     1         host_dir(iat)(1:lentrim(host_dir(iat)))
           tmplen=lentrim(tmp)
           
        
c jump here to return status code stored in tmp
 2000  tmplen=max(1,lentrim(tmp))
        call CopyResult( tmp,tmplen, retstr )
       deallocate( tmp )
       deallocate(arg1,stat=ierr1)
       deallocate(arg2,stat=ierr1)
       deallocate(arg3,stat=ierr1)

       SRE_HOSTINFO = VALID_ROUTINE

       return

       end



