/* this is the Sre2000 installation program */

lister='E'              /* your favorite text viewer/editor ! */

nowdir=directory()
adir=filespec("drive",nowdir)

defmain=adir||'\SRE2K'

call init_it
crlf='0d0a'x

cls
say  " " ; say

call lineout, bold cy_ye
call lineout, "This is the Sre2000 installation program (BETA -- 12 May 2000)."
call lineout, normal


do forever
  a=yesno(" Would you like to ",'Install ViewInfo Quit ','V')

  if a=2 then do
    say "See you later... "
    exit
  end 
  if a=1 then call show_info
  if a=0 then leave
end

/* Ready to start installing */
say clearscreen
say white_red||copies('-',27)||'  Installing '||white_red||copies('-',27)||normal

say

/* call check_macro -- don't need to do */

call check_tcpip

say bold'Select the installation directory 'normal
workdir=get_dir(defmain)


/* create some secondary directories */
say 
say "    Checking for several subdirectories (creating if necessary ... "
gosds='DATA MANUALS OLD '
do ii=1 to words(gosds)
       a1=strip(word(gosds,ii))
       mdd=workdir'\'a1
       if dosisdir(mdd)=0 then do
          oo=sysmkdir(mdd)
          if oo<>0 then do 
            say 'ERROR: Could not create 'mdd ', error code= ' oo
            exit
         end /* do */
       end
end

datadir=workdir'\DATA'
manualdir=workdir'\MANUALS'
olddir=workdir'\OLD'


/* ************* 
****  NOT YET SUPPORTED ... (archive old version) ***
foo=sysfiletree(workdir'\SRE2000.RX*','goo','F')
if goo.0>0 then do
   say
   say bold "Prior version of Sre2000 detected."normal
   aa=yesno('  Archive this version to 'workdir'\OLD')
   if aa=1 then do

   end
end 
else do
   say
end 
***********/

/* now start copying files */

say 
say bold"Copying "normal" Sre2000 program files to: "reverse||workdir||normal

foo=yesno("Continue? ")
if foo=0 then do
   say "see you later ...."
   exit
end

foo1=check_COPY('*.RX*',workdir,,1)
caa='GOS2SRE.CMD DOPUT.CMD DODELETE.CMD DOPOST.CMD DOGET.CMD MOD_INI.CMD SRE2000.CMD'
do mm=1 to words(caa)
  aw=strip(word(caa,mm))
  foo1=check_COPY(aw,workdir,,1)
end 

say 
say bold"Copying "normal" library files and helper apps "
foo1=check_COPY('*.DLL',workdir,,1)
foo1=check_COPY('*.RXL',workdir,,1)
foo1=check_COPY('*.IDX',workdir,,1)
foo1=check_COPY('TZSET.EXE',workdir,,1)


say bold"Copying "normal" documentation files to: "reverse||manualdir||normal
foo1=check_copy('*.DOC',manualdir,,1)
foo1=check_copy('*.TXT',manualdir,,1)
foo1=check_copy('*.HTM',manualdir,,1)
foo1=check_copy('*.GIF',manualdir,,1)


say bold"Copying "normal" sample parameter files to: "reverse||datadir||normal
foo1=check_copy('BADIPS.IN',datadir)
say bold"Copying configuration file to: " reverse||workdir||normal
foo1=check_copy('SRE2000.CFG',workdir)


/* remind people about need to install filter, etc */
say clearscreen
say white_red||copies('-',22)||'  Installation complete '||white_red||copies('-',22)||normal
say
say "Sre2000 had been successfully installed to: "bold||workdir||normal
say
say reverse"Notes: "normal
say
say " * By default, Sre2000 uses SIMPLE.RXX as a filter -- this will get you"
say "   started, but for serious web-serving you should get a more complete filter,"
say "   such as SREhttp/2 (http://www.srehttp.org/)"
say
say " * To start Sre2000, run SRE2000.CMD from an OS/2 command prompt."
say "   For example: "
say "      "workdir'>'bold'sre2000'normal
say
say  " * To configure, run Sre2000.CMD with a -m or -mall switch. For example:"
say "      "workdir'>'bold'Sre2000 -m'normal
say
say "  * The Sre2000 manual is "manualdir'\Sre2000.DOC'
say 
aa=yesno(normal'    'reverse'Would you like to view the Sre2000 manual')
if aa=1 then do  
  say "Viewing Sre2000.DOC .... "
     '@START  "The SRE2000 documentation!" /C  /WIN 'lister' ' manualdir'\Sre2000.DOC'
end  

'@cd 'workdir

say


exit




/* ------------------------ */
/* ask for directory name,use defname2 as default */
/* give user opportunity to create it */
get_dir:procedure expose normal reverse bold re_wh making
/* procedure expose reverse normal bold */
parse arg defname2 , mustsub
defname0=defname2

n2:
call charout , '    'reverse' <ENTER>=' defname2  normal ' ?'
pull godir

if godir=" " then godir=defname2
if godir="n.a." then signal n2


if mustsub<>"" then do    /* check 'must be subdirectory' option */
  if abbrev(godir,mustsub)=0 then do
     say " This directory MUST be under the " mustsub " directory! "
     say "  .. please re enter ! "
     signal n2
  end
end

godir=strip(godir,'t','\')
gdname=godir||"\*.*"


isme=directory()

isnew=directory(godir)
if isnew="" then do
   say "    Could not find  " godir
   if yesno(normal"        "re_wh"Would you like to create it")=1 then do
        making=1
        oo=sysmkdir2(godir)
        if oo=0  then
           say "      Directory created: " godir
        else do
           say "      Could not create " godir "(error = " oo
           if godir=defname2 then defname2= "n.a."
           signal n2
        end
   end
   else do
        say " please reenter directory name ... "
        if godir=defname2 then defname2= "n.a."
        signal n2
   end
end  /* Do */

isme=directory(isme)

return godir







/********************/
/* first, check tcp/ip version -- suggest upgrade */
check_tcpip:
'@inetver | rxqueue '
pull oy
parse var oy . ':' aver 
parse var aver mainver '.' subver
if mainver='4' then do
  if subver<'02T' then do
      say
      say bold"WARNING: " normal" Your TCP/IP version is "aver
      say "           We "bold"STRONGLY"normal" recommend upgrading to 4.02t (or above)"
     if yesno(" Continue installing SREhttp/s (and upgrade TCP/IP later)?")=1 then do
        say "   Okay, but you may experience sporadic errors."
        say ' '
     end
     else do
        say "As of 10 Dec 1998, 4.02t info can be found at: "
        say "   ftp://ps.software.ibm.com/ps/products/tcpip/rsu/stack/latestv4.html"
        say
        say "See you later.... "
        exit
     end /* do */
  end
end
return 1


/*********************/
show_info:
say
do forever
  aa=yesno(' View the: ','Abstract Disclaimer  quit ','DISCLAIMER')
  select 
     when aa=0 then call show_abstract
     when aa=1 then call show_disclaim

/*     when aa=2 then do  
      say "Viewing Sre2000.DOC .... "
       '@START  "The SRE2000 documentation!" /C  /WIN 'lister' Sre2000.DOC'
     end 
 */
     otherwise return 0
  end  
say
end


/*********************************/
/* display the disclaimer */

show_disclaim:
say ' '
say white_red||copies('-',77)||normal

say  "                "cy_ye"Summary of the Sre2000 disclaimer"normal
say bold"         The complete disclaimer is  contained in READ.ME"normal
say "  With some provisos, permission to use programs comprising the Sre2000 "
say "  package, for any purpose, is hereby granted without fee. "
say "  These provisos include:" 
say "   * the author's name may not be used in advertising or "
say "     publicity pertaining to distribution of the software "
say "     without specific written prior permision."
say "   * The authors of Sre2000, and any potentially affiliated institutions,"
say "     disclaim any and all liability for damages due to the use, misuse, or"
say "     failure of this product or related products."
say "         In particular, Sre2000 and related products are NOT "
say "         guaranteed to be secure.  Although we design and code our "
say "         product with attention to potential security holes, "
say "         we can NOT guarantee security."
say white_red||copies('-',77)||normal

return


/*********************/
show_abstract:


say white_red||copies('-',77)||normal

say '                           '   bold cy_ye' Abstract'normal
say ' '
say '    Sre2000 is an http/1.1 server for OS/2.  More precisely,'
say '    Sre2000 provides a set of functions and capabilties that allow'
say '    you to implement a web server through a "filter" program that '
say '    is written in REXX. Several filter programs are publically available, '
say '    such as SREhttp/2 - or you can write your own.'
say ' '
say bold||'    For the full manual,'normal' see  SRE2000.DOC (or SRE2000.HTM)'

say ' '
say bold||' Are you are upgrading from GoServe/SRE-http? 'normal
say "     ... then you'll find a number of hints and suggestions in UPGRADER.TXT!"
say' '

say white_red||copies('-',77)||normal
say 



/***************/
init_it:

/* Load up advanced REXX functions */
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

nowdir=directory()

initfilt_file=''
init_sta_file=''
copyall=0
echo off


/* --- Load the tcp/ip function library, if necessary --- */
if RxFuncQuery("SockLoadFuncs")=1 then  do    /* not there */
  call RxFuncAdd "SockLoadFuncs","rxSock","SockLoadFuncs"
  call SockLoadFuncs
end

thishost=' '


parse version  atype .
if atype<>"REXXSAA" then do
 say    " WARNING: SRE2000 is designed to work under OS/2 Classic Rexx "
 say     " Other versions of REXX, such as Object REXX and Quercus's REXX, "
 say     " have not been tested."
 say " Note: You are using REXX version: " atype
 say " (hit ENTER to continue) "
  pull .
end  /* Do */


dropunz=0 ;
foo=rxfuncquery('UZLoadFuncs')   /* load UNZIP dll */
if foo=1 then do
  dropunz=1
  call RxFuncAdd 'UZLoadFuncs', 'UNZIPAPI', 'UZLoadFuncs'
  call UZLoadFuncs
end
foo=rxfuncquery('UZLoadFuncs')
gotunz=1
if foo=1 then do
    say " Can not find UNZIP procedure library: UNZIPAPI.DLL"
    say "  Did you download it? "
    say " (hit ENTER to continue)"
    parse pull gunk
    gotunz=0 ; dropunz=0
end  /* Do */

/*---- load the rexxlib library */
droprxlib=0 ; gotrxlib=1
foo=rxfuncquery('rexxlibregister')
if foo=1 then do
 droprxlib=1 ; gotrxlib=0
 call rxfuncadd 'rexxlibregister','rexxlib', 'rexxlibregister'
 call rexxlibregister
end
foo=rxfuncquery('rexxlibregister')
if foo=1 then do
    say " Could not find the REXXLIB procedure library (REXXLIB.DLL). "
    say "  Did you download it? "
    exit
end  /* Do */


  aesc='1B'x
  clearscreen=aesc||'[2J'
  cy_ye=aesc||'[38;46;m'
  normal=aesc||'[0;m'
  bold=aesc||'[1;m'
  re_wh=aesc||'[31;47;m'
  white_red=aesc||'[37;41;m'
  reverse=aesc||'[7;m'

/* some defaults */
    datadir="your GoServe Data-directory"
    workdir="your GoServe Working-directory"
   workdir_notset=1
    helpdir='the SAMPLES/ subdirectory of the GoServe Data-directory'
    useindex='  '


return 0


/*********/
check_macro:
     say " We recommend clearing macrospace before you install Sre2000."
     say " However, this might adversely impact other programs (that may also "
     say " use REXX's macrospace). "
     ok=yesno(" Clear macrospace now ?",,'Y')
     if ok=1 then do
        say " .... clearing macrospace "
        foo=macroclear()
        say " "
     end  /* Do */
     else do
        say  bold "Macrospace will not be cleared. " normal
        say " When you are ready to run Sre2000, we recommend "
        say " that you first reboot your server."
          say " "
     end 
return 0



/*********************/

/* choose between 3 alternatives (by default,a yes or no ),
return 1 if yes (or 0,1,2 for chosen altenative ) */

yesno:procedure expose normal reverse bold cy_ye 
parse arg amessage , altans,def,arrowok
ony2:
aynn=' '
if def='' then
 defans=''
else
 defans=translate(left(strip(def),1))
if altans='' then altans='No Yes'

w.0=words(altans)
goo=aynn
do iw0=1 to w.0
     w.iw0=strip(word(altans,iw0))
     a.iw0=translate(left(w.iw0,1))
     aa.iw0=substr(w.iw0,2)
     aynn=aynn||bold
     if  a.iw0=defans then aynn=aynn||cy_ye
     aynn=aynn||a.iw0||normal||aa.iw0
     goo=goo||a.iw0||aa.iw0
     if iw0<w.0 then do
       if noansi=0 then
          aynn=aynn'  '
       else
          aynn=aynn'  '
       goo=goo||'  '
     end
end
if arrowok=1 then aynn=aynn||' [UP]'

do forever
 foo1=normal||reverse||amessage||'? '||normal||aynn||': 'normal
 goo=amessage'?'||goo':'

 if length(goo)<73 then do 
    call charout,foo1
 end
 else do
    foo1=normal||reverse||amessage||'? '||normal
    say foo1
    call charout,'     : 'aynn||': 'normal
 end 

 anans=translate(sysgetkey('echo'))

 if anans='?' then do   /* asking for help */
     call online_help varname
     say
     signal ony2
 end /* do */
 else

 ianans=c2d(anans)
 if anans='' | ianans=13 | ianans=10 then  anans=defans

 if arrowok=1 & ianans=0  then do
     ians=c2d(sysgetkey('noecho'))
     if ians=72 then  do
           say ;say
           return -1  /* -1 : up key */
     end
 end /* do */

 do ijj=1 to w.0
    if abbrev(anans,a.ijj)=1 then do
        say
        return Ijj-1
    end
 end /* do */
 call charout,'0d'x
end


/* ------------- */
sysmkdir2:procedure
parse arg adir

adir=strip(adir,'t','\')
ff=sysmkdir(adir)
if ff=0 then return ff

/* make the tree */
f2=adir'\'
dd=filespec('d',f2)
pp=filespec('p',f2)
if pp='\' | pp='' then return -1

pp2=strip(translate(pp,' ','\'))

do mm=1 to words(pp2)
   a1=subword(pp2,1,mm)
   a1=translate(a1,'\',' ')
   dd2=dd'\'a1
   hoo=sysmkdir(dd2)
   if hoo=0 then say ' ... creating: 'dd2  
end /* do */

return hoo


/*******************************************/
/* check for existence of file, then ask user to copy or not */
/* note that for X.* type copies, it only checks once
   (not for each file, but just for any one of them */
/********************************************/
check_copy: procedure expose copyall reverse bold normal re_wh olddir
parse arg file1, dest1 , amess , noask

dest2=strip(dest1,'t','\')||'\'

filename=dest1
if pos('.',dest1)=0 then filename=dest2||file1

if copyall=1 then signal doit3

aa=sysfiletree(filename,isit,'F')
ok=1
if aa<>0 then do
   say " Warning: error when looking for pre-existing copy of: " filename
   ok=yesno("   Do you want to copy this file (or files) anyways? ")
   if ok=1 & amess<>""  then
      ok=yesno(amess)
end

if noask=1 then signal doit3

if isit.0>0 then do
  if pos('*',file1)=0 then do
      say " "
      say " A file exists with the name: " filename
      ok=yesno(" Do you want to overwrite this file? ")
      if ok=0 then do
        say "Current version of " filename " will be retained."
        return 0
     end

     daname=filespec('n',filename)
     ip=pos('.',daname)
     if ip=0 then do
         bakfile=olddir||'\'||daname||'.V??'
     end
     else do
        bakfile=olddir||'\'||left(daname,ip)||'V??'
      end
     bakfile=dostempname(bakfile)
     say daname ' is being renamed as '  bakfile
     foo=dosrename(filename,bakfile)
     if foo=0 then   say " Warning: ERROR renaming! "
     say ' '
  end

  else do
    say " "
      say " There is at least one file that matches: " filename
      say "  (this match may " bold " not " normal " be one of the files that will be copied!) "
      ok=yesno(" Do you want to copy these files? ")
      if ok=0 then return 0
  end  
end

doit3:          /* jump here if copyall is on, or noask=1 */
'COPY ' file1 dest1 ' > NUL '

return 1




