/* This will create SRE2000.RXL : basic Sre2000
functions to be loaded into MacroSpace.  Run this if
you modify the source code of the library files (the .SRF files).
*/

parse arg doit .
foo=rxfuncquery('rexxlibregister')
if foo=1 then do
 say ' loading REXXLIB '
 call rxfuncadd 'rexxlibregister','rexxlib', 'rexxlibregister'
 call rexxlibregister
end
/*--------------   Load REXX libraries ----- */
/* Load up advanced REXX functions */
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs


names.0=0
procname_list=';DO NOT MODIFY this list of procedures in the SRE2000.RXL macrospace library '

say " Create SRE2000 macrospace procedure library. "
say " This requires that macrospace be cleared (which might effect"
say " other OS/2 programs)"

if doit=1 then signal go1
call charout,'  Enter 1 if you wish to proceed: '
parse pull gogo
if gogo<>1 then do
   say "Nothing done."
   exit
end
go1:
foo=macroclear()
if foo=0 then
    say "Warning: Problem clearing macrospace. "
else
  say "Macrospace cleared ... "


say "Loading  procedures "
retc=macroadd2('SRE_COMMAND','COMMAND.SRF','Before')
retc=macroadd2('SRE_SOCKIN','SOCKIN.SRF','Before')
retc=macroadd2('SRE_SOCK_NONCHUNK','BODYNON.SRF','Before')
retc=macroadd2('SRE_SOCK_CHUNK','BODYCHUN.SRF','Before')
retc=macroadd2('SRE_AUDIT','AUDITLOG.SRF','Before')
retc=macroadd2('SRE_CACHE_WRITE','CACHEIT.SRF','Before')
retc=macroadd2('SRE_SAY','SRESAY.SRF','Before')
retc=macroadd2('SRE_TRACKIT','TRACKIT.SRF','Before')
retc=macroadd2('DATADIR','DATADIR.SRF','BEFORE')
retc=macroadd2('SRE_ADD_CACHE_HIT','HMETER.SRF','Before')
retc=macroadd2('SRE_MD5','MD5C.SRF','Before')
retc=macroadd2('PACKUR','PACKUR.SRF','Before')
retc=macroadd2('COMPLETED','COMPLETD.SRF','Before')
retc=macroadd2('REQFIELD','REQFIELD.SRF','BEFORE') 
retc=macroadd2('STILL_ALIVE','ALIVE.SRF','BEFORE') 
retc=macroadd2('CLIENTNAME','CLIENTNA.SRF','BEFORE')
retc=macroadd2('EXTRACT','EXTRACT.SRF','Before')
retc=macroadd2('CACHED','CACHED.SRF','Before')
retc=macroadd2('GMTOFFSET','GMTOFF.SRF','Before')
retc=macroadd2('PACK64','PACK64.SRF','Before')
retc=macroadd2('SERVER','SERVSOFT.SRF','Before')
retc=macroadd2('SRE_CONTROL','CONTROL.SRF','Before')
retc=macroadd2('SERVERNAME','SERVERNM.SRF','Before')
retc=macroadd2('ADD_TH','ADDTH.SRF','Before')
retc=macroadd2('SRE_DATESTAMP','GMTDATE.SRF','Before')
retc=macroadd2('SRE_ADDCOMMA','ADDCOMMA.SRF','Before')

        /************* END OF PROCEDURES ********/

/* now create procname list */
foo=sysfiledelete('SRE2000.IDX')
foo=stream('SRE2000.IDX','c','open write')
wow=charout('SRE2000.IDX',procname_list,1)
foo=stream('SRE2000.IDX','c','close')


say " saving macrospace procedures to SRE2000.RXL"
foo=macrosave('SRE2000.RXL')
if foo<>1 then 
   say "Error creating SRE2000.RXL : " foo
else
   say " success! "
exit


/****/
macroadd2:procedure expose procname_list
parse arg a1,a2,a3
procname_list=procname_list||'0d0a'x||a1
if stream(a2,'c','query exists')='' then 
   say "ERROR: could not find " a2
else
  foo=macroadd(a1,a2,a3)
return foo

