c read/ save variables in static space -- "counter" variables

c$define INCL_REXXSAA
c$include rexxsaa.fap

! Declare our exported function.  Export it!

c$pragma aux (RexxFunctionHandler) SRE_COUNTVARS "SRE_COUNTVARS"

! SRE_COUNTVARS -- store variables 

c$noreference
	integer function SRE_COUNTVARS( name, numargs, args,
     &                            queuename, retstr )
c$reference

	character*(*) name, queuename
	integer numargs
	record /RXSTRING/ retstr, args(numargs)
        
	include 'rxsutils.fi'

	character*(*) tmp,arg1,arg2

        character *250 aline
        character *2 crlf

        character *25 globnames(:)
        integer  globvals(:)
        integer nglobals,ii
        save globnames,globvals,nglobals  !for storing global variables
        volatile globnames,globvals,nglobals  !for storing global variables

        integer maxglobals
        save maxglobals
        volatile maxglobals
        data maxglobals/-1/

        logical qreset
        integer setlength,ierr1,mm,tmplen,jadd

c gotta be a few arguments
	if( numargs .lt. 1.or.numargs.gt.2 )then
           SRE_COUNTVARS = 443
           return
	endif

        tmplen=40
        allocate(tmp*tmplen)

        allocate( arg1*args(1).strlength, location=args(1).strptr )
        call strip_arg(arg1)

        setlength=0
        jadd=0                ! assume no augmentation
        qreset=.false.
        if (numargs.gt.1) then
         if (args(2).strlength.gt.0) then          !get the value 
            allocate( arg2*args(2).strlength, location=args(2).strptr)
            setlength=args(2).strlength
            call strip_arg(arg2)
            if (arg2.eq.'RESET') then
                qreset=.true.
            else
               read(arg2,*,iostat=ierr1)jadd
               if (ierr1.ne.0) jadd=0
            endif       !reset
         else
            allocate(arg2*1)
            arg2=' '
         endif          !arg2 exists
        
       endif            !numargs > 1

       if (arg1.eq.'!STARTUP') then
           nglobals=0
           if (setlength.eq.0) then 
                maxglobals=50
                ierr1=0
           else
               read(arg2,*,iostat=ierr1)maxglobals
           endif
           tmp='ok'
           if (ierr1.ne.0) tmp='error_reading_maxcounts'
           deallocate(globnames,stat=ierr1)
           deallocate(globvals,stat=ierr1)
           allocate(globnames(maxglobals),stat=ierr1)
           if (ierr1.ne.0) tmp='error_allocating_countnames'
           allocate(globvals(maxglobals),stat=ierr1)
           if (ierr1.ne.0) tmp='error_allocating_countvals'
           goto 2000
        endif

        if (arg1.eq.'!RESET') then 
           do mm=1,nglobals
              globvals(mm)=0
           enddo
           tmp='ok'
           goto 2000
         endif
           
        if (maxglobals.lt.0) then
          tmp='error_conutvars_not_initialized'
          goto 2000
        endif

c return info?
        if (arg1.eq.'INFO'.or.arg1.eq.'!INFO') then
           execute do_info
           goto 2000
         endif


c  Note: global variables are not robust against rapid changes by many threads

       do mm=1,nglobals
          if (globnames(mm)(1:3).ne.arg1(1:3)) cycle  ! preliminary check
          if (globnames(mm).ne.arg1) cycle              !full check
          if (setlength.eq.0) then           !return value
                write(tmp,*,iostat=ierr1)globvals(mm)
                if (ierr1.ne.0) tmp='error_writing_countvalue'
                goto 2000
           else                       !replace value
               if (qreset) then
                  globvals(mm)=0
                  tmp='reset_ok'
               else
                   globvals(mm)=globvals(mm)+jadd
                   write(tmp,*,iostat=ierr1)globvals(mm)
                  if (ierr1.ne.0) tmp='error_writing_countvalue'
               endif
               goto 2000
           endif
       enddo

c global not found -- create a new one
        if (nglobals.ge.maxglobals) then
             tmp='error_too_many_counts'
             goto 2000
         endif
         tmp='ok'
         nglobals=nglobals+1
         globvals(nglobals)=jadd
         globnames(nglobals)=arg1
         goto 2000

c jump here to return status code stored in tmp
 2000  tmplen=max(1,lentrim(tmp))
       call CopyResult( tmp,tmplen, retstr )
       deallocate( tmp )
       deallocate(arg1,stat=ierr1)
       deallocate(arg2,stat=ierr1)
       SRE_COUNTVARS = VALID_ROUTINE
       return



c------------- Info  ----
       remote block do_info  

        deallocate(tmp,stat=ierr1)

        II=180+(80*NGLOBALS)
        ALLOCATE(TMP*II)

        crlf(1:1)=char(13)
        crlf(2:2)=char(10)

        write(tmp,991,iostat=ierr1)nglobals,maxglobals,
     1          crlf,crlf,crlf
 991    format('Using ',i6,
     1         ' of ',i6,' possible variables= ',a,
     1      '  Variable                   :        Value ',a,
     1      ' ---------------------------------------------',a)

        if (ierr1.ne.0) then
           tmp='error_writing_ctstatus_info'
           exit
        endif

        do mm=1,nglobals
           write(aline,992)globnames(mm),globvals(mm),crlf
 992       format(2x,a25,2x,': ',i10,a)
           CALL ADD_STRING(TMP,ALINE)
        enddo
        exit
        end block


        end



