c read/ save variables in static space -- to a revolving cache

c$define INCL_REXXSAA
c$include rexxsaa.fap

! Declare our exported function.  Export it!

c$pragma aux (RexxFunctionHandler) SRE_CACHE_IPNAME "SRE_CACHE_IPNAME"

! SRE_CACHE_IPNAME -- store variables 

c$noreference
	integer function SRE_CACHE_IPNAME( name, numargs, args,
     &                            queuename, retstr )
c$reference

	character*(*) name, queuename
	integer numargs
	record /RXSTRING/ retstr, args(numargs)
        
	include 'rxsutils.fi'

	character*(*) tmp,arg1,arg2

        character *200 aline
        character *2 crlf

        character *50  globnames(:)
        character *80 globvals(:)
        integer nnn
        save globnames,globvals  !for storing global variables
        volatile globnames,globvals  !for storing global variables

        integer maxglobals
        save maxglobals
        volatile maxglobals
        data maxglobals/-1/

        integer setlength,mm,tmplen,ierr1,ii
        integer jextfree,mm2

        integer *2 globindx2(:),globindx1(:)                !1=back, 2=forward
        integer *2 hashtable(2048)
        save hashtable,globindx1,globindx2
        volatile hashtable,globindx1,globindx2

        integer jash,indx1,find_hashtable2,fig_hashval
        integer nextfree,tooremove
        integer iprior,iprior2,inext,itmp
        save nextfree,tooremove
        volatile nextfree,tooremove

        integer islocked
        save islocked
        volatile islocked
        data islocked/0/

        tmplen=80
        deallocate(tmp,stat=ierr1)
        allocate(tmp*tmplen)

c gotta be a few arguments
	if( numargs .lt. 1.or.numargs.gt.2 )then
           SRE_CACHE_IPNAME = 443
           return
	endif

        allocate( arg1*args(1).strlength, location=args(1).strptr )
        call strip_arg(arg1)

        setlength=0
        if (numargs.gt.1) then
         if (args(2).strlength.gt.0) then          !get the value 
            allocate( arg2*args(2).strlength, location=args(2).strptr )
            setlength=args(2).strlength
         else
             allocate(arg2*1)
             arg2=' '
         endif
       endif

        if (arg1.eq.'!STARTUP'.or.arg1.eq.'!RESET') then
           islocked=1

           if (arg1.eq.'!STARTUP') then
             nextfree=-1
             if (setlength.eq.0) then 
                maxglobals=100
                ierr1=0
             else
                 read(arg2,*,iostat=ierr1)maxglobals
             endif
             tmp='ok'
             if (ierr1.ne.0) tmp='error_reading_maxcacheIP'
           endif
           tooremove=int(maxglobals/8)

           if (arg1.eq.'!RESET') then
              call wait_asec(0.02)               ! pause for .02 seconds
           endif                                !so as to let others finish
           deallocate(globnames,stat=ierr1)
           deallocate(globvals,stat=ierr1)
           deallocate(globindx1,stat=ierr1)
           deallocate(globindx2,stat=ierr1)

           allocate(globnames(maxglobals),stat=ierr1)
           if (ierr1.ne.0) then
                tmp='error_allocating_cacheIP'
                goto 2000
           endif
           allocate(globvals(maxglobals),stat=ierr1)
           if (ierr1.ne.0) then
                 tmp='error_allocating_cacheIPb'
                 goto 2000
           endif

           allocate(globindx1(maxglobals),stat=ierr1)
           if (ierr1.ne.0) then
             write(tmp,9811)ierr1
 9811        format('error_allocating_globindx1IP=',i6)
                goto 2000
           endif

           allocate(globindx2(maxglobals),stat=ierr1)
           if (ierr1.ne.0) then
              write(tmp,9821)ierr1
 9821         format('error_allocating_globindx2IP=',i6)
                goto 2000
           endif

           do mm=1,2048
                hashtable(mm)=0
           enddo
           do mm=1,maxglobals
                globindx1(mm)=0
                globindx2(mm)=0
                globnames(mm)=' '
           enddo

           nextfree=0
           goto 2000
        endif

c make sure things have been initialized....           
        if (maxglobals.lt.0) then
          tmp='error_cacheIP_not_initialized'
          goto 2000
        endif

c are we "locked"?
        if (islocked.eq.1) then    !  wait for lock to be released
           call wait_asec(0.01)    ! WAIT 1/100 second
           if (islocked.eq.1) then  ! still locked? 
              tmp=' '               
              goto 2000
           endif
        endif

c info?
        if (arg1.eq.'!INFO') then 
           execute do_info
           goto 2000
        endif

c  Note: global variables are not robust against rapid changes by many threads

       if (nextfree.lt.0) then           ! -1 means "suppress lookups while initializing
          tmp=' '
          goto 2000
        endif

       jash=fig_hashval(arg1)
       indx1=find_hashtable2(jash,arg1,hashtable,globnames,
     1                        globindx2,maxglobals)


C MATCH not found 
        if (indx1.eq.0) then            ! match not found

          if (setlength.eq.0) then              !not setting 
              tmp=' '                    !return ' ' (if not setting )
              goto 2000
          endif

c add new value at "nextfree+1", or at 1 if nextfree+1> maxglobals
          nextfree=nextfree+1
          if (nextfree.gt.maxglobals)nextfree=1
        
c is this slot used? If so, detach it and fix links

         iprior=globindx1(nextfree)

c unused slot?
         if (Iprior.ne.0) then          ! used -- so remove next several
            jextfree=nextfree
            inext=globindx2(nextfree)
            do mm2=1,tooremove
             if (iprior.lt.0) then
                 iprior2=-iprior          
                 hashtable(iprior2)=inext    ! connect hashtable to next in list 
                 if (inext.gt.0) globindx1(inext)=iprior    ! and next in list points back to hashtable (use - val
              endif
              if (iprior.gt.0) then         ! excise from interior, or end, of list
                globindx2(iprior)=inext
                if (inext.gt.0) globindx1(inext)=iprior
              endif                           !iprior=0 means "unused cell"
              globindx1(jextfree)=0
              globindx2(jextfree)=0
              globnames(jextfree)=' '
              globvals(jextfree)=' '
c       write(6,666)jextfree
c 666    format(' zapping ',i6)
              jextfree=jextfree+1
              if (jextfree.gt.maxglobals)jextfree=1
              iprior=globindx1(jextfree)
              inext=globindx2(jextfree)
            enddo
         endif

c now create cell and insert at head of list (pointed to by a hashlist element)
          write(tmp,*,iostat=ierr1)arg2
          if (ierr1.ne.0) then                         ! error writing value
             tmp='error_writing_cacheIP'
             goto 2000
          endif

          globvals(nextfree)=arg2         !now fill these in
          globnames(nextfree)=arg1 
          itmp=hashtable(jash)
          globindx2(nextfree)=itmp        ! should be 0 if "Free slot"
          if (itmp.ne.0) globindx1(itmp)=nextfree !#1 becomes #2, and points back here
          globindx1(nextfree)=-jash     !- means "position in hashtable" (as head of list)
          hashtable(jash)=nextfree          

c Match found
        else                    ! MATCH was found 

           if (setlength.gt.0) then             !set new value
               globvals(indx1)=arg2
            endif
            write(tmp,*,iostat=ierr1)globvals(indx1)
            if (ierr1.ne.0) then                         ! error writing value
                tmp='error_writing_sysvarvalueIP'
                goto 2000
            endif
        endif

c jump here to return status code stored in tmp
 2000  tmplen=max(1,lentrim(tmp))
       call CopyResult( tmp,tmplen, retstr )
       deallocate( tmp )
       deallocate(arg1,stat=ierr1)
       deallocate(arg2,stat=ierr1)
       if (islocked.eq.1) islocked=0
       SRE_CACHE_IPNAME = VALID_ROUTINE
       return



c------------- Info  ----
       remote block do_info  

        deallocate(tmp,stat=ierr1)

        II=180+(170*maxgLOBALS)
        ALLOCATE(TMP*II) 

        crlf(1:1)=char(13)
        crlf(2:2)=char(10)

        nnn=0
        do mm=1,maxglobals
           if (globnames(mm).ne.' ') nnn=nnn+1
        enddo

        write(tmp,991,iostat=ierr1)nnn,maxglobals,crlf
 991    format('Storing ',i6,' of ',i6,' values ',a)

        if (ierr1.ne.0) then
           tmp='error_writing_status_infoIP'
           exit
        endif

        do mm=1,maxglobals
           if (globnames(mm).eq.' ')cycle
           write(aline,992)globnames(mm),
     1           globvals(mm)(1:lentrim(globvals(mm))),crlf
 992       format(2x,a25,2x,': ',a,a)
           CALL ADD_STRING(TMP,ALINE)
        enddo
        exit
        end block

        end



