c save current values, and comptue stats on them

c$define INCL_REXXSAA
c$include rexxsaa.fap

! Declare our exported function.  Export it!

c$pragma aux (RexxFunctionHandler) SRE_SAVEVALS "SRE_SAVEVALS"

! SRE_SAVEVALS -- store variables 

c$noreference
	integer function SRE_SAVEVALS( name, numargs, args,
     &                            queuename, retstr )
c$reference

	character*(*) name, queuename
	integer numargs
	record /RXSTRING/ retstr, args(numargs)
        
	include 'rxsutils.fi'

	character*(*) tmp,arg1,arg2,arg3

        character *2 crlf
        character *25 colnames(:)
        character *80 aline
        character *25 aword
        REAL LISTVALS(:,:)
        integer mostrecents(:),mostrecent
        logical qfulls(:),qfull
        save colnames,listvals,qfulls,mostrecents  !for storing global variables
        volatile colnames,listvals,qfulls,mostrecents  !for storing global variables

        integer maxvalues,ncols,jcol
        save maxvalues,ncols
        volatile maxvalues,ncols

        data maxvalues,ncols/-1,0/

        integer i2,ii,i1,ndo,jadd
        real cadd,ammin,ammax,Asum,asum2
C        integer mmin,mmax
        real asd,anobs

        integer setlength,mm,tmplen,ierr1,setlength3,mm2,iat2

        tmplen=80
        deallocate(tmp,stat=ierr1)
        allocate(tmp*tmplen)

c gotta be a few arguments
	if( numargs .lt. 1)then
           SRE_SAVEVALS = 443
           return
	endif

        allocate( arg1*args(1).strlength, location=args(1).strptr )
        call strip_arg(arg1)

c might need 2nd and 3rd arguments
        setlength=0
        if (numargs.gt.1) then
         if (args(2).strlength.gt.0) then          !get the value 
            allocate( arg2*args(2).strlength, location=args(2).strptr )
            call strip_arg(arg2)
            setlength=args(2).strlength
         else
            allocate(arg2*1)
            arg2=' '
         endif
       endif
       setlength3=0
       if (numargs.gt.2) then
         if (args(3).strlength.gt.0) then          !get the value 
            allocate( arg3*args(3).strlength, location=args(3).strptr )
            call strip_arg(arg3)
            setlength3=args(3).strlength
         else
            allocate(arg3*1)
            arg3=' '
         endif
       endif

c Arg1=!Startup:  
       if (arg1.eq.'STARTUP'.or.arg1.eq.'!STARTUP') then
          execute do_startup
          goto 2000
       endif

c check for initialization
        if (maxvalues.lt.0) then
          tmp='error_savevals_not_initialized'
          goto 2000
        endif

c return info?
        if (arg1.eq.'INFO'.or.arg1.eq.'!INFO'.or.arg1.eq.'!VALUES') then
           execute do_info
           goto 2000
         endif


        if (arg1.eq.'!VARLIST') then 
           ii=max(80,ncols*28)
           deallocate(tmp,stat=ierr1)
           allocate(tmp*ii)
           tmp=' '
           do mm=1,ncols
              write(aline,994)colnames(mm)
              tmplen=lentrim(tmp)+1
              tmp(tmplen:ii)=aline
          enddo
          goto 2000
        endif


c reset
        if (arg1.eq.'!RESET') then
           do jcol=1,ncols
             qfulls(jcol)=.false.
             mostrecents(jcol)=0
           enddo
           tmp='ok'
           goto 2000
        endif

c  Note: global variables are not robust against rapid changes by many threads

C Determine WHICH COLUMN TO CHECK

       jcol=1                            !default to 1st column 
       if (setlength.gt.0) then         ! possibly a named column
         jcol=0
         DO mm=1,ncols
           if (arg2.eq.colnames(mm)) then
              jcol=mm
              exit
           endif
         enddo
         if (jcol.eq.0) then
            tmp='error_undefined_column:'//arg2
            goto 2000
         endif
       endif

c Clear this column?
        if (arg1.eq.'CLEAR') then
           qfulls(jcol)=.false.
           mostrecents(jcol)=0
           tmp='ok'
           goto 2000
        endif


       qfull=qfulls(jcol)
       mostrecent=mostrecents(jcol)

c # of values used to compute statistics?
       if (arg1.eq.'NOBS') then
          ndo=maxvalues                  
          if (.not.qfull)ndo=mostrecent
          write(tmp,*)ndo
          goto 2000
       endif

c determine how far back to look up (if forming stats)
        if (arg1.eq.'SUM'.or.arg1.eq.'MEAN'.or.arg1.eq.'SD'
     1      .or.arg1.eq.'MINMAX') then

            if (mostrecent.eq.0 .and. .not.qfull) then
                tmp=' '
                goto 2000
            endif

             ndo=maxvalues                     ! #values to use (or use all?)
             if (.not.qfull)ndo=mostrecent
             if (setlength3.ne.0) then
                read(arg3,*,iostat=ierr1)ndo
                if (ierr1.ne.0) then
                    tmp='error_reading_ndo'
                    goto  2000
                endif
                if (qfull) then
                    ndo=max(1,min(ndo,maxvalues))
                else
                    ndo=max(1,min(mostrecent,ndo))
                endif
             endif

             i2=mostrecent
             i1=1+i2-ndo
         endif


c how much to add? Or do an action?

       if (arg1.eq.'SUM'.or.arg1.eq.'MEAN'.or.arg1.eq.'SD') then  !some stats
c do ndo most recent?
          asum=0
          asum2=0
          anobs=0
          do mm=i1,i2           ! compute sum(x) and sum(x**2)
             anobs=anobs+1
             ii=mm
             if (mm.lt.1)ii=maxvalues+ii
             asum=asum+listvals(ii,jcol)
             if (arg1.eq.'SD') asum2=asum2+(listvals(ii,jcol)**2)
          enddo
          if (arg1.eq.'SD') then                !use sums to compute stats
                asum=Asum/anobs
                asum2=Asum2/anobs    
                asd=asum2-(asum*asum)
                if (asd.ge.0) then
                   asd=sqrt(asd)
                   write(tmp,*)asd
                else
                   tmp='error'
                endif
          elseif (arg1.eq.'MEAN')then
                asum=Asum/anobs
                write(tmp,*)asum
          else
                write(tmp,*)Asum
          endif
          goto 2000

       elseif (arg1.eq.'MINMAX') then           !min max stats
          ammin=1000000000
          ammax=-1
          do mm=i1,i2
             ii=mm
             if (mm.lt.1)ii=maxvalues+ii
             ammin=min(ammin,listvals(ii,jcol))
             ammax=max(ammax,listvals(ii,jcol))
          enddo
          write(tmp,*)Ammin,Ammax
          goto 2000
          
       elseif (arg1.eq.'CLEAR')   then             !reset column
          qfulls(jcol)=.false.
          mostrecents(jcol)=0
          tmp='ok'
          goto 2000

       else             ! insert a value
          if (index(arg1,'.').eq.0) then
             read(arg1,*,iostat=ierr1)jadd
             cadd=jadd
          else
             read(arg1,*,iostat=ierr1)cadd
          endif
         
          if (ierr1.ne.0) then
              tmp='error_bad_value'
              goto 2000
          endif
       endif
        
c ---- add value to to jcol column

        tmp='ok'
        mostrecent=mostrecent+1
        if (mostrecent.gt.maxvalues) then
           mostrecent=1
           qfulls(jcol)=.true.
        endif
        listvals(mostrecent,jcol)=cadd
        mostrecents(jcol)=mostrecent
        goto 2000


c jump here to return status code stored in tmp
 2000  tmplen=max(1,lentrim(tmp))
       call CopyResult( tmp,tmplen, retstr )
       deallocate( tmp )
       deallocate(arg1,stat=ierr1)
       deallocate(arg2,stat=ierr1)
       SRE_SAVEVALS = VALID_ROUTINE
       return


c ------------------- blocks ----
c    arg2=# of rows  -- default=100
c    arg3 ... argn : column names. Default is ' '

       remote block do_startup

       if (setlength.eq.0) then 
           maxvalues=100
        else
           read(arg2,*,iostat=ierr1)maxvalues
           if (ierr1.ne.0) then
               tmp='error_reading_maxvalues'
               maxvalues=-1
               exit
           endif
        endif
        
        ncols=max(1,numargs-2)

        tmp='ok'
        deallocate(colnames,stat=ierr1)
        deallocate(listvals,stat=ierr1)
        DEALLOCATE(QFULLS,STAT=IERR1)
        DEALLOCATE(MOSTRECENTS,STAT=IERR1)


        allocate(colnames(ncols),stat=ierr1)
        if (ierr1.ne.0) then
            tmp='error_allocating_colnames'
            maxvalues=-1
            exit
        endif

        allocate(mostrecents(ncols),stat=ierr1)
        if (ierr1.ne.0) then
           tmp='error_allocating_mostrecents'
            maxvalues=-1
            exit
        endif

        allocate(qfulls(ncols),stat=ierr1)
        if (ierr1.ne.0) then
            tmp='error_allocating_qfulls'
            maxvalues=-1
            exit
        endif

        allocate(listvals(maxvalues,ncols),stat=ierr1)
        if (ierr1.ne.0) then
            tmp='error_allocating_listvals'
            maxvalues=-1
            exit
        endif
                
        do mm=1,ncols
             qfulls(mm)=.false.
             mostrecents(Mm)=0
             colnames(mm)=' '
        enddo
        colnames(1)='VALUES'            !default name

        do mm=3,numargs                 !assing column names
          if (args(mm).strlength.eq.0) cycle      !check for empty argumnets   
          deallocate(arg3,stat=ierr1)
          allocate( arg3*args(mm).strlength, 
     1                  location=args(mm).strptr )
          call strip_arg(arg3)
          colnames(mm-2)=arg3
        enddo                           !assigning colnames

        exit
        end block

c------------- Info  ----
       remote block do_info  

        deallocate(tmp)

c 80 : # of values, # of columns
c 20+ncols*30: column names
c 20+ncols*10: number of values

        crlf(1:1)=char(13)
        crlf(2:2)=char(10)
        ii=320+ ((4+maxvalues)*ncols*24)
        allocate(tmp*ii,stat=ierr1)
        tmp=' '
        if (ierr1.ne.0) exit            !fatal error?
        write(aline,991)maxvalues,ncols

 991    format('Max # of observations= ',i7,', # of variables=',i7)
        tmp=aline
        tmplen=lentrim(tmp)
        tmp(tmplen+1:tmplen+2)=crlf
        tmplen=tmplen+3

        tmp(tmplen:ii)='Column names:'
        do mm=1,ncols
           write(aline,994)colnames(mm)

 994       format(' ',a)
           tmplen=lentrim(tmp)+1
           tmp(tmplen:ii)=aline
        enddo
        tmplen=lentrim(tmp)
        tmp(tmplen+1:tmplen+2)=crlf
        tmplen=tmplen+3

        tmp(tmplen:ii)='# of values: '
        do mm=1,ncols
           jadd=mostrecents(mm)
           if (qfulls(mm))jadd=maxvalues
           write(aline,894)jadd

 894       format('  ',i8,'   ')
           tmplen=lentrim(tmp)+1
           tmp(tmplen:ii)=aline
        enddo

c now compute stats for each column 

        if (arg1.ne.'!VALUES') exit

        tmplen=lentrim(tmp)
        tmp(tmplen+1:tmplen+2)=crlf
        tmplen=tmplen+3

        do mm=1,maxvalues
           aline=' '
           do mm2=1,ncols
             iat2=12+((mm2-1)*14)
             jadd=mostrecents(mm2)
             if (qfulls(mm2))jadd=maxvalues
             if (mm.gt.jadd) then
                 aline(iat2:iat2+11)=' '
             else
                 write(aword,997)listvals(mm,mm2)
 997             format(f12.3)     
                 aline(iat2:iat2+11)=aword
             endif
           enddo
           if (aline.eq.' ') exit
           tmplen=lentrim(tmp)+1
           tmp(tmplen:ii)=aline
           tmp(tmplen+1:tmplen+2)=crlf
           tmplen=tmplen+3
        enddo

        exit
        end block

c --- end of blocks ---

        end



